SystemOrganization addCategory: #'GBT-DSL_Forum'!

Object subclass: #GbtForumA
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_Forum'!

!GbtForumA class methodsFor: 'example' stamp: 'hk 1/26/2017 18:33'!
exampleClear
	GbtAppService clearStore. 
	GbtSVO initialize. ! !

!GbtForumA class methodsFor: 'example' stamp: 'CC 1/18/2017 14:12'!
exampleRun
	(self new forumAApp: '') open! !

!GbtForumA methodsFor: 'contexts' stamp: 'hk 1/21/2017 15:34'!
forumAApp: userName  
	"(self new forumAApp: '' ) open" 

	^GbtPlainAC newStruct: 'ForumAApp'  for: userName define: {
		{#aspect:on: . self forumACtx: userName . #customer } .
		{#uiSpec:icon: . #GbtMainUI . #forumA} .
		"note - the icon name (#forumA) is also used as an internal uiKey. 
		The icon itself is not used in MainUI and may be missing"
		{#extent: . (1000 @ 800)}.
	}! !

!GbtForumA methodsFor: 'contexts' stamp: 'CC 1/20/2017 22:02'!
forumACtx: userName  
	"(self new forumA: '' ) open" 

	^GbtBigListAC newStruct: 'ForumA'  for: userName define: {
		{#displayAs: . 'ForumAList'} .
		{#noPolicyPrefix: . 'Forum'}.
		{#uiSpec:icon: . #GbtListAndItemUI . #contacts} .
		{#templates: . self forumAItem} .
		{#loadPolicy: . #autoload } .
		{#display: . #(#(Name forumName)  category threads messages views)} .
		{#subcontext: . self forumAItemCtx: userName}}! !

!GbtForumA methodsFor: 'things' stamp: 'CC 1/20/2017 22:04'!
forumAItem
	"self new forumAItem edit"
	
	^GbtThing newStruct: 'ForumAItem' define: {
		{ #Name . #val: . 'forum 1'}.
		{ #threads . #listOf: . self threadA}.
		{ #threadCount .  #sum: . #tcount}.
	} full: { 
		{ #category . #val: . 'cat 1'}.
		{ #messageCount .  #no: . 0}.
		{ #viewCount .  #no: . 0}.
	}! !

!GbtForumA methodsFor: 'contexts' stamp: 'hk 1/19/2017 12:23'!
forumAItemCtx: userName  
	^GbtPlainAC newStruct: 'ForumAItemContext'  for: userName define: {
		{#displayAs: . 'a Forum'  } .
		{#uiSpec:icon: . #GbtItemWithTabsUI . #contacts }.
		{#aspect:on: . self threadsACtx: userName . #threads } .
	}! !

!GbtForumA methodsFor: 'contexts' stamp: 'hk 1/21/2017 15:23'!
repliesACtx: userName  
	^GbtUlistAC newStruct: 'RepliesAContext'  for: userName define: {
		{#displayAs: . 'replies in a thread'  } .
		{#noPolicyPrefix: . 'Thread'}.
		{#template:for: . self replyA . #Replies }.
		{#subcontext: . self replyACtx: userName}.
		{#uiSpec:icon: . #GbtListAndItemUI . #contacts}.
	}! !

!GbtForumA methodsFor: 'things' stamp: 'CC 1/18/2017 13:48'!
replyA
	"self new replyA edit"
	
	^GbtThing newStruct: 'ReplyA' define: {
		{ #Id . #val: . ''}.
		{ #ReplyDataTime . #val: . ''}.
	} full: { 
		{ #PostedBy . #val: . ''}.
		{ #Message .  #val: . ''}.
	}! !

!GbtForumA methodsFor: 'contexts' stamp: 'CC 1/20/2017 21:53'!
replyACtx: userName  
	^GbtPlainAC newStruct: 'ReplyAContext'  for: userName define: {
		{#displayAs: . 'reply'  } .
		{#uiSpec:icon: . #GbtItemUI . #contacts}.
	}! !

!GbtForumA methodsFor: 'things' stamp: 'hk 1/21/2017 15:37'!
threadA
	"self threadA edit"
	^GbtThing newStruct: 'ThreadA' define: {
		{ #ForumName . #ref: . #R:Name}.
		{ #Subject . #val: . ''}.
		{ #Replies . #listOf: . self replyA}.
		{ #tcount . #no: . 1 }
	} full: { 
		{ #LastPostedBy . #val: . ''}.
		{ #Message .  #val: . ''}.
		{ #replies .  #no: . 0}.
		{ #views .  #no: . 0}.
	}! !

!GbtForumA methodsFor: 'contexts' stamp: 'hk 1/21/2017 19:54'!
threadACtx: userName  
	^GbtPlainAC newStruct: 'ThreadAContext'  for: userName define: {
		{#displayAs: . 'thread'  } .
		{#uiSpec:icon: . #GbtItemWithTabsUI . #contact}.
		{#aspect:on: . self repliesACtx: userName . #replies } .
	}
	! !

!GbtForumA methodsFor: 'contexts' stamp: 'CC 1/20/2017 22:05'!
threadsACtx: userName  
	^GbtUlistAC newStruct: 'ThreadsAContext'  for: userName define: {
		{#displayAs: . 'discussion threads'  } .
		{#noPolicyPrefix: . 'Thread'}.
		{#template:for: . self threadA . #threads }.
		{#subcontext: . self threadACtx: userName }.
		{#uiSpec:icon: . #GbtListAndItemUI . #contacts}.
	}! !

Object subclass: #GbtForumB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_Forum'!
